
namespace eval ::tk::dialog {}
namespace eval ::tk::dialog::file {}

namespace eval ::tk::dialog::file::chooseDir {
namespace import -force ::tk::msgcat::*
}

proc ::tk::dialog::file::chooseDir:: {args} {
variable ::tk::Priv
set dataName __tk_choosedir
upvar ::tk::dialog::file::$dataName data
::tk::dialog::file::chooseDir::Config $dataName $args

if {[string equal $data(-parent) .]} {
set w .$dataName
} else {
set w $data(-parent).$dataName
}

if {![winfo exists $w]} {
::tk::dialog::file::Create $w TkChooseDir
} elseif {[string compare [winfo class $w] TkChooseDir]} {
destroy $w
::tk::dialog::file::Create $w TkChooseDir
} else {
set data(dirMenuBtn) $w.f1.menu
set data(dirMenu) $w.f1.menu.menu
set data(upBtn) $w.f1.up
set data(icons) $w.icons
set data(ent) $w.f2.ent
set data(okBtn) $w.f2.ok
set data(cancelBtn) $w.f2.cancel
set data(hiddenBtn) $w.f2.hidden
}
if {$::tk::dialog::file::showHiddenBtn} {
$data(hiddenBtn) configure -state normal
grid $data(hiddenBtn)
} else {
$data(hiddenBtn) configure -state disabled
grid remove $data(hiddenBtn)
}


if {[winfo viewable [winfo toplevel $data(-parent)]] } {
wm transient $w $data(-parent)
}

trace variable data(selectPath) w [list ::tk::dialog::file::SetPath $w]
$data(dirMenuBtn) configure  -textvariable ::tk::dialog::file::${dataName}(selectPath)

set data(filter) "*"
set data(previousEntryText) ""
::tk::dialog::file::UpdateWhenIdle $w


::tk::PlaceWindow $w widget $data(-parent)
wm title $w $data(-title)


::tk::SetFocusGrab $w $data(ent)
$data(ent) delete 0 end
$data(ent) insert 0 $data(selectPath)
$data(ent) selection range 0 end
$data(ent) icursor end


vwait ::tk::Priv(selectFilePath)

::tk::RestoreFocusGrab $w $data(ent) withdraw


foreach trace [trace vinfo data(selectPath)] {
trace vdelete data(selectPath) [lindex $trace 0] [lindex $trace 1]
}
$data(dirMenuBtn) configure -textvariable {}


return $Priv(selectFilePath)
}

proc ::tk::dialog::file::chooseDir::Config {dataName argList} {
upvar ::tk::dialog::file::$dataName data

foreach trace [trace vinfo data(selectPath)] {
trace vdelete data(selectPath) [lindex $trace 0] [lindex $trace 1]
}

set specs {
{-mustexist "" "" 0}
{-initialdir "" "" ""}
{-parent "" "" "."}
{-title "" "" ""}
}

if {![info exists data(selectPath)]} {
set data(selectPath) [pwd]
}

tclParseConfigSpec ::tk::dialog::file::$dataName $specs "" $argList

if {$data(-title) == ""} {
set data(-title) "[mc "Choose Directory"]"
}

set data(-multiple) 0

if {$data(-initialdir) != ""} {
if {[file isdirectory $data(-initialdir)]} {
set old [pwd]
cd $data(-initialdir)
set data(selectPath) [pwd]
cd $old
} else {
set data(selectPath) [pwd]
}
}

if {![winfo exists $data(-parent)]} {
error "bad window path name \"$data(-parent)\""
}
}

proc ::tk::dialog::file::chooseDir::OkCmd {w} {
upvar ::tk::dialog::file::[winfo name $w] data


set selection [tk::IconList_Curselection $data(icons)]
if { [llength $selection] != 0 } {
set iconText [tk::IconList_Get $data(icons) [lindex $selection 0]]
set iconText [file join $data(selectPath) $iconText]
::tk::dialog::file::chooseDir::Done $w $iconText
} else {
set text [$data(ent) get]
if { [string equal $text ""] } {
return
}
set text [eval file join [file split [string trim $text]]]
if { ![file exists $text] || ![file isdirectory $text] } {
if { [string equal $text $data(previousEntryText)] } {
set data(previousEntryText) ""
::tk::dialog::file::chooseDir::Done $w $text
} else {
set data(previousEntryText) $text
}
} else {
if { [string equal $text $data(selectPath)] } {
::tk::dialog::file::chooseDir::Done $w $text
} else {
set data(selectPath) $text
}
}
}
return
}

proc ::tk::dialog::file::chooseDir::DblClick {w} {
upvar ::tk::dialog::file::[winfo name $w] data
set selection [tk::IconList_Curselection $data(icons)]
if { [llength $selection] != 0 } {
set filenameFragment  [tk::IconList_Get $data(icons) [lindex $selection 0]]
set file $data(selectPath)
if {[file isdirectory $file]} {
::tk::dialog::file::ListInvoke $w [list $filenameFragment]
return
}
}
}

proc ::tk::dialog::file::chooseDir::ListBrowse {w text} {
upvar ::tk::dialog::file::[winfo name $w] data

if {[string equal $text ""]} {
return
}

set file [::tk::dialog::file::JoinFile $data(selectPath) $text]
$data(ent) delete 0 end
$data(ent) insert 0 $file
}

proc ::tk::dialog::file::chooseDir::Done {w {selectFilePath ""}} {
upvar ::tk::dialog::file::[winfo name $w] data
variable ::tk::Priv

if {[string equal $selectFilePath ""]} {
set selectFilePath $data(selectPath)
}
if { $data(-mustexist) } {
if { ![file exists $selectFilePath] ||  ![file isdir $selectFilePath] } {
return
}
}
set Priv(selectFilePath) $selectFilePath
}
