

proc ::tk_dialog {w title text bitmap default args} {
global tcl_platform
variable ::tk::Priv

if {[string is int $default]} {
if {$default >= [llength $args]} {
return -code error "default button index greater than number of buttons specified for tk_dialog"
}
} elseif {[string equal {} $default]} {
set default -1
} else {
set default [lsearch -exact $args $default]
}


catch {destroy $w}
toplevel $w -class Dialog
wm title $w $title
wm iconname $w Dialog
wm protocol $w WM_DELETE_WINDOW { }

if {[winfo viewable [winfo toplevel [winfo parent $w]]] } {
wm transient $w [winfo toplevel [winfo parent $w]]
}

if {[string equal $tcl_platform(platform) "macintosh"]
|| [string equal [tk windowingsystem] "aqua"]} {
::tk::unsupported::MacWindowStyle style $w dBoxProc
}

frame $w.bot
frame $w.top
if {[string equal [tk windowingsystem] "x11"]} {
$w.bot configure -relief raised -bd 1
$w.top configure -relief raised -bd 1
}
pack $w.bot -side bottom -fill both
pack $w.top -side top -fill both -expand 1


option add *Dialog.msg.wrapLength 3i widgetDefault
if {[string equal $tcl_platform(platform) "macintosh"]
|| [string equal [tk windowingsystem] "aqua"]} {
option add *Dialog.msg.font system widgetDefault
} else {
option add *Dialog.msg.font {Times 12} widgetDefault
}

label $w.msg -justify left -text $text
pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
if {$bitmap ne ""} {
if {($tcl_platform(platform) eq "macintosh"
|| [tk windowingsystem] eq "aqua") && ($bitmap eq "error")} {
set bitmap "stop"
}
label $w.bitmap -bitmap $bitmap
pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
}


set i 0
foreach but $args {
button $w.button$i -text $but -command [list set ::tk::Priv(button) $i]
if {$i == $default} {
$w.button$i configure -default active
} else {
$w.button$i configure -default normal
}
grid $w.button$i -in $w.bot -column $i -row 0 -sticky ew  -padx 10 -pady 4
grid columnconfigure $w.bot $i
if {[string equal $tcl_platform(platform) "macintosh"]
|| [string equal [tk windowingsystem] "aqua"]} {
set tmp [string tolower $but]
if {[string equal $tmp "ok"] || [string equal $tmp "cancel"]} {
grid columnconfigure $w.bot $i -minsize [expr {59 + 20}]
}
}
incr i
}


if {$default >= 0} {
bind $w <Return> "
[list $w.button$default] configure -state active -relief sunken
update idletasks
after 100
set ::tk::Priv(button) $default
"
}


bind $w <Destroy> {set ::tk::Priv(button) -1}


wm withdraw $w
update idletasks
set x [expr {[winfo screenwidth $w]/2 - [winfo reqwidth $w]/2  - [winfo vrootx [winfo parent $w]]}]
set y [expr {[winfo screenheight $w]/2 - [winfo reqheight $w]/2  - [winfo vrooty [winfo parent $w]]}]
if {$x < 0} {
set x 0
}
if {$y < 0} {
set y 0
}
wm maxsize $w [winfo screenwidth $w] [winfo screenheight $w]
wm geometry $w +$x+$y
wm deiconify $w

tkwait visibility $w


set oldFocus [focus]
set oldGrab [grab current $w]
if {$oldGrab ne ""} {
set grabStatus [grab status $oldGrab]
}
grab $w
if {$default >= 0} {
focus $w.button$default
} else {
focus $w
}


vwait ::tk::Priv(button)
catch {focus $oldFocus}
catch {

bind $w <Destroy> {}
destroy $w
}
if {$oldGrab ne ""} {
if {$grabStatus ne "global"} {
grab $oldGrab
} else {
grab -global $oldGrab
}
}
return $Priv(button)
}
