



bind Listbox <1> {
if {[winfo exists %W]} {
tk::ListboxBeginSelect %W [%W index @%x,%y]
}
}


bind Listbox <Double-1> {
}

bind Listbox <B1-Motion> {
set tk::Priv(x) %x
set tk::Priv(y) %y
tk::ListboxMotion %W [%W index @%x,%y]
}
bind Listbox <ButtonRelease-1> {
tk::CancelRepeat
%W activate @%x,%y
}
bind Listbox <Shift-1> {
tk::ListboxBeginExtend %W [%W index @%x,%y]
}
bind Listbox <Control-1> {
tk::ListboxBeginToggle %W [%W index @%x,%y]
}
bind Listbox <B1-Leave> {
set tk::Priv(x) %x
set tk::Priv(y) %y
tk::ListboxAutoScan %W
}
bind Listbox <B1-Enter> {
tk::CancelRepeat
}

bind Listbox <Up> {
tk::ListboxUpDown %W -1
}
bind Listbox <Shift-Up> {
tk::ListboxExtendUpDown %W -1
}
bind Listbox <Down> {
tk::ListboxUpDown %W 1
}
bind Listbox <Shift-Down> {
tk::ListboxExtendUpDown %W 1
}
bind Listbox <Left> {
%W xview scroll -1 units
}
bind Listbox <Control-Left> {
%W xview scroll -1 pages
}
bind Listbox <Right> {
%W xview scroll 1 units
}
bind Listbox <Control-Right> {
%W xview scroll 1 pages
}
bind Listbox <Prior> {
%W yview scroll -1 pages
%W activate @0,0
}
bind Listbox <Next> {
%W yview scroll 1 pages
%W activate @0,0
}
bind Listbox <Control-Prior> {
%W xview scroll -1 pages
}
bind Listbox <Control-Next> {
%W xview scroll 1 pages
}
bind Listbox <Home> {
%W xview moveto 0
}
bind Listbox <End> {
%W xview moveto 1
}
bind Listbox <Control-Home> {
%W activate 0
%W see 0
%W selection clear 0 end
%W selection set 0
event generate %W <<ListboxSelect>>
}
bind Listbox <Shift-Control-Home> {
tk::ListboxDataExtend %W 0
}
bind Listbox <Control-End> {
%W activate end
%W see end
%W selection clear 0 end
%W selection set end
event generate %W <<ListboxSelect>>
}
bind Listbox <Shift-Control-End> {
tk::ListboxDataExtend %W [%W index end]
}
bind Listbox <<Copy>> {
if {[string equal [selection own -displayof %W] "%W"]} {
clipboard clear -displayof %W
clipboard append -displayof %W [selection get -displayof %W]
}
}
bind Listbox <space> {
tk::ListboxBeginSelect %W [%W index active]
}
bind Listbox <Select> {
tk::ListboxBeginSelect %W [%W index active]
}
bind Listbox <Control-Shift-space> {
tk::ListboxBeginExtend %W [%W index active]
}
bind Listbox <Shift-Select> {
tk::ListboxBeginExtend %W [%W index active]
}
bind Listbox <Escape> {
tk::ListboxCancel %W
}
bind Listbox <Control-slash> {
tk::ListboxSelectAll %W
}
bind Listbox <Control-backslash> {
if {[string compare [%W cget -selectmode] "browse"]} {
%W selection clear 0 end
event generate %W <<ListboxSelect>>
}
}


bind Listbox <2> {
%W scan mark %x %y
}
bind Listbox <B2-Motion> {
%W scan dragto %x %y
}


if {[string equal [tk windowingsystem] "classic"]
|| [string equal [tk windowingsystem] "aqua"]} {
bind Listbox <MouseWheel> {
%W yview scroll [expr {- (%D)}] units
}
bind Listbox <Option-MouseWheel> {
%W yview scroll [expr {-10 * (%D)}] units
}
bind Listbox <Shift-MouseWheel> {
%W xview scroll [expr {- (%D)}] units
}
bind Listbox <Shift-Option-MouseWheel> {
%W xview scroll [expr {-10 * (%D)}] units
}
} else {
bind Listbox <MouseWheel> {
%W yview scroll [expr {- (%D / 120) * 4}] units
}
}

if {[string equal "x11" [tk windowingsystem]]} {
bind Listbox <4> {
if {!$tk_strictMotif} {
%W yview scroll -5 units
}
}
bind Listbox <5> {
if {!$tk_strictMotif} {
%W yview scroll 5 units
}
}
}


proc ::tk::ListboxBeginSelect {w el} {
variable ::tk::Priv
if {[string equal [$w cget -selectmode] "multiple"]} {
if {[$w selection includes $el]} {
$w selection clear $el
} else {
$w selection set $el
}
} else {
$w selection clear 0 end
$w selection set $el
$w selection anchor $el
set Priv(listboxSelection) {}
set Priv(listboxPrev) $el
}
event generate $w <<ListboxSelect>>
}


proc ::tk::ListboxMotion {w el} {
variable ::tk::Priv
if {$el == $Priv(listboxPrev)} {
return
}
set anchor [$w index anchor]
switch [$w cget -selectmode] {
browse {
$w selection clear 0 end
$w selection set $el
set Priv(listboxPrev) $el
event generate $w <<ListboxSelect>>
}
extended {
set i $Priv(listboxPrev)
if {[string equal {} $i]} {
set i $el
$w selection set $el
}
if {[$w selection includes anchor]} {
$w selection clear $i $el
$w selection set anchor $el
} else {
$w selection clear $i $el
$w selection clear anchor $el
}
if {![info exists Priv(listboxSelection)]} {
set Priv(listboxSelection) [$w curselection]
}
while {($i < $el) && ($i < $anchor)} {
if {[lsearch $Priv(listboxSelection) $i] >= 0} {
$w selection set $i
}
incr i
}
while {($i > $el) && ($i > $anchor)} {
if {[lsearch $Priv(listboxSelection) $i] >= 0} {
$w selection set $i
}
incr i -1
}
set Priv(listboxPrev) $el
event generate $w <<ListboxSelect>>
}
}
}


proc ::tk::ListboxBeginExtend {w el} {
if {[string equal [$w cget -selectmode] "extended"]} {
if {[$w selection includes anchor]} {
ListboxMotion $w $el
} else {
ListboxBeginSelect $w $el
}
}
}


proc ::tk::ListboxBeginToggle {w el} {
variable ::tk::Priv
if {[string equal [$w cget -selectmode] "extended"]} {
set Priv(listboxSelection) [$w curselection]
set Priv(listboxPrev) $el
$w selection anchor $el
if {[$w selection includes $el]} {
$w selection clear $el
} else {
$w selection set $el
}
event generate $w <<ListboxSelect>>
}
}


proc ::tk::ListboxAutoScan {w} {
variable ::tk::Priv
if {![winfo exists $w]} return
set x $Priv(x)
set y $Priv(y)
if {$y >= [winfo height $w]} {
$w yview scroll 1 units
} elseif {$y < 0} {
$w yview scroll -1 units
} elseif {$x >= [winfo width $w]} {
$w xview scroll 2 units
} elseif {$x < 0} {
$w xview scroll -2 units
} else {
return
}
ListboxMotion $w [$w index @$x,$y]
set Priv(afterId) [after 50 [list tk::ListboxAutoScan $w]]
}


proc ::tk::ListboxUpDown {w amount} {
variable ::tk::Priv
$w activate [expr {[$w index active] + $amount}]
$w see active
switch [$w cget -selectmode] {
browse {
$w selection clear 0 end
$w selection set active
event generate $w <<ListboxSelect>>
}
extended {
$w selection clear 0 end
$w selection set active
$w selection anchor active
set Priv(listboxPrev) [$w index active]
set Priv(listboxSelection) {}
event generate $w <<ListboxSelect>>
}
}
}


proc ::tk::ListboxExtendUpDown {w amount} {
variable ::tk::Priv
if {[string compare [$w cget -selectmode] "extended"]} {
return
}
set active [$w index active]
if {![info exists Priv(listboxSelection)]} {
$w selection set $active
set Priv(listboxSelection) [$w curselection]
}
$w activate [expr {$active + $amount}]
$w see active
ListboxMotion $w [$w index active]
}


proc ::tk::ListboxDataExtend {w el} {
set mode [$w cget -selectmode]
if {[string equal $mode "extended"]} {
$w activate $el
$w see $el
if {[$w selection includes anchor]} {
ListboxMotion $w $el
}
} elseif {[string equal $mode "multiple"]} {
$w activate $el
$w see $el
}
}


proc ::tk::ListboxCancel w {
variable ::tk::Priv
if {[string compare [$w cget -selectmode] "extended"]} {
return
}
set first [$w index anchor]
set last $Priv(listboxPrev)
if { [string equal $last ""] } {
return
}
if {$first > $last} {
set tmp $first
set first $last
set last $tmp
}
$w selection clear $first $last
while {$first <= $last} {
if {[lsearch $Priv(listboxSelection) $first] >= 0} {
$w selection set $first
}
incr first
}
event generate $w <<ListboxSelect>>
}


proc ::tk::ListboxSelectAll w {
set mode [$w cget -selectmode]
if {[string equal $mode "single"] || [string equal $mode "browse"]} {
$w selection clear 0 end
$w selection set active
} else {
$w selection set 0 end
}
event generate $w <<ListboxSelect>>
}
