



bind Menubutton <FocusIn> {}
bind Menubutton <Enter> {
tk::MbEnter %W
}
bind Menubutton <Leave> {
tk::MbLeave %W
}
bind Menubutton <1> {
if {$tk::Priv(inMenubutton) ne ""} {
tk::MbPost $tk::Priv(inMenubutton) %X %Y
}
}
bind Menubutton <Motion> {
tk::MbMotion %W up %X %Y
}
bind Menubutton <B1-Motion> {
tk::MbMotion %W down %X %Y
}
bind Menubutton <ButtonRelease-1> {
tk::MbButtonUp %W
}
bind Menubutton <space> {
tk::MbPost %W
tk::MenuFirstEntry [%W cget -menu]
}


bind Menu <FocusIn> {}

bind Menu <Enter> {
set tk::Priv(window) %W
if {[%W cget -type] eq "tearoff"} {
if {"%m" ne "NotifyUngrab"} {
if {[tk windowingsystem] eq "x11"} {
tk_menuSetFocus %W
}
}
}
tk::MenuMotion %W %x %y %s
}

bind Menu <Leave> {
tk::MenuLeave %W %X %Y %s
}
bind Menu <Motion> {
tk::MenuMotion %W %x %y %s
}
bind Menu <ButtonPress> {
tk::MenuButtonDown %W
}
bind Menu <ButtonRelease> {
tk::MenuInvoke %W 1
}
bind Menu <space> {
tk::MenuInvoke %W 0
}
bind Menu <Return> {
tk::MenuInvoke %W 0
}
bind Menu <Escape> {
tk::MenuEscape %W
}
bind Menu <Left> {
tk::MenuLeftArrow %W
}
bind Menu <Right> {
tk::MenuRightArrow %W
}
bind Menu <Up> {
tk::MenuUpArrow %W
}
bind Menu <Down> {
tk::MenuDownArrow %W
}
bind Menu <KeyPress> {
tk::TraverseWithinMenu %W %A
}


if {[string equal [tk windowingsystem] "x11"]} {
bind all <Alt-KeyPress> {
tk::TraverseToMenu %W %A
}

bind all <F10> {
tk::FirstMenu %W
}
} else {
bind Menubutton <Alt-KeyPress> {
tk::TraverseToMenu %W %A
}

bind Menubutton <F10> {
tk::FirstMenu %W
}
}


proc ::tk::MbEnter w {
variable ::tk::Priv

if {[string compare $Priv(inMenubutton) ""]} {
MbLeave $Priv(inMenubutton)
}
set Priv(inMenubutton) $w
if {[string compare [$w cget -state] "disabled"]} {
$w configure -state active
}
}


proc ::tk::MbLeave w {
variable ::tk::Priv

set Priv(inMenubutton) {}
if {![winfo exists $w]} {
return
}
if {[string equal [$w cget -state] "active"]} {
$w configure -state normal
}
}


proc ::tk::MbPost {w {x {}} {y {}}} {
global errorInfo
variable ::tk::Priv
global tcl_platform

if {[$w cget -state] eq "disabled" || $w eq $Priv(postedMb)} {
return
}
set menu [$w cget -menu]
if {[string equal $menu ""]} {
return
}
set tearoff [expr {[tk windowingsystem] eq "x11"  || [$menu cget -type] eq "tearoff"}]
if {[string first $w $menu] != 0} {
error "can't post $menu:  it isn't a descendant of $w (this is a new requirement in Tk versions 3.0 and later)"
}
set cur $Priv(postedMb)
if {[string compare $cur ""]} {
MenuUnpost {}
}
set Priv(cursor) [$w cget -cursor]
set Priv(relief) [$w cget -relief]
$w configure -cursor arrow
$w configure -relief raised

set Priv(postedMb) $w
set Priv(focus) [focus]
$menu activate none
GenerateMenuSelect $menu


update idletasks
if {[catch {
switch [$w cget -direction] {
above {
set x [winfo rootx $w]
set y [expr {[winfo rooty $w] - [winfo reqheight $menu]}]
if {$y < 0} {
set y [expr {[winfo rooty $w] + [winfo height $w]}]
}
PostOverPoint $menu $x $y
}
below {
set x [winfo rootx $w]
set y [expr {[winfo rooty $w] + [winfo height $w]}]
set mh [winfo reqheight $menu]
if {($y + $mh) > [winfo screenheight $w]} {
set y [expr {[winfo rooty $w] - $mh}]
}
PostOverPoint $menu $x $y
}
left {
set x [expr {[winfo rootx $w] - [winfo reqwidth $menu]}]
set y [expr {(2 * [winfo rooty $w] + [winfo height $w]) / 2}]
set entry [MenuFindName $menu [$w cget -text]]
if {[$w cget -indicatoron]} {
if {$entry == [$menu index last]} {
incr y [expr {-([$menu yposition $entry]  + [winfo reqheight $menu])/2}]
} else {
incr y [expr {-([$menu yposition $entry]  + [$menu yposition [expr {$entry+1}]])/2}]
}
}
PostOverPoint $menu $x $y
if {$entry ne ""  && [$menu entrycget $entry -state] ne "disabled"} {
$menu activate $entry
GenerateMenuSelect $menu
}
}
right {
set x [expr {[winfo rootx $w] + [winfo width $w]}]
set y [expr {(2 * [winfo rooty $w] + [winfo height $w]) / 2}]
set entry [MenuFindName $menu [$w cget -text]]
if {[$w cget -indicatoron]} {
if {$entry == [$menu index last]} {
incr y [expr {-([$menu yposition $entry]  + [winfo reqheight $menu])/2}]
} else {
incr y [expr {-([$menu yposition $entry]  + [$menu yposition [expr {$entry+1}]])/2}]
}
}
PostOverPoint $menu $x $y
if {$entry ne ""  && [$menu entrycget $entry -state] ne "disabled"} {
$menu activate $entry
GenerateMenuSelect $menu
}
}
default {
if {[$w cget -indicatoron]} {
if {[string equal $y {}]} {
set x [expr {[winfo rootx $w] + [winfo width $w]/2}]
set y [expr {[winfo rooty $w] + [winfo height $w]/2}]
}
PostOverPoint $menu $x $y [MenuFindName $menu [$w cget -text]]
} else {
PostOverPoint $menu [winfo rootx $w] [expr {[winfo rooty $w]+[winfo height $w]}]
}
}
}
} msg]} {

set savedInfo $errorInfo
MenuUnpost {}
error $msg $savedInfo

}

set Priv(tearoff) $tearoff
if {$tearoff != 0} {
focus $menu
if {[winfo viewable $w]} {
SaveGrabInfo $w
grab -global $w
}
}
}


proc ::tk::MenuUnpost menu {
global tcl_platform
variable ::tk::Priv
set mb $Priv(postedMb)


catch {focus $Priv(focus)}
set Priv(focus) ""


catch {
if {[string compare $mb ""]} {
set menu [$mb cget -menu]
$menu unpost
set Priv(postedMb) {}
$mb configure -cursor $Priv(cursor)
$mb configure -relief $Priv(relief)
} elseif {[string compare $Priv(popup) ""]} {
$Priv(popup) unpost
set Priv(popup) {}
} elseif {[string compare [$menu cget -type] "menubar"]  && [string compare [$menu cget -type] "tearoff"]} {

while {1} {
set parent [winfo parent $menu]
if {[string compare [winfo class $parent] "Menu"]  || ![winfo ismapped $parent]} {
break
}
$parent activate none
$parent postcascade none
GenerateMenuSelect $parent
set type [$parent cget -type]
if {[string equal $type "menubar"] ||  [string equal $type "tearoff"]} {
break
}
set menu $parent
}
if {[string compare [$menu cget -type] "menubar"]} {
$menu unpost
}
}
}

if {($Priv(tearoff) != 0) || $Priv(menuBar) ne ""} {
if {[string compare $menu ""]} {
set grab [grab current $menu]
if {[string compare $grab ""]} {
grab release $grab
}
}
RestoreOldGrab
if {$Priv(menuBar) ne ""} {
$Priv(menuBar) configure -cursor $Priv(cursor)
set Priv(menuBar) {}
}
if {[tk windowingsystem] ne "x11"} {
set Priv(tearoff) 0
}
}
}


proc ::tk::MbMotion {w upDown rootx rooty} {
variable ::tk::Priv

if {[string equal $Priv(inMenubutton) $w]} {
return
}
set new [winfo containing $rootx $rooty]
if {[string compare $new $Priv(inMenubutton)]  && ([string equal $new ""]  || [string equal [winfo toplevel $new] [winfo toplevel $w]])} {
if {[string compare $Priv(inMenubutton) ""]} {
MbLeave $Priv(inMenubutton)
}
if {[string compare $new ""]  && [string equal [winfo class $new] "Menubutton"]  && ([$new cget -indicatoron] == 0)  && ([$w cget -indicatoron] == 0)} {
if {[string equal $upDown "down"]} {
MbPost $new $rootx $rooty
} else {
MbEnter $new
}
}
}
}


proc ::tk::MbButtonUp w {
variable ::tk::Priv
global tcl_platform

set menu [$w cget -menu]
set tearoff [expr {[tk windowingsystem] eq "x11" ||  ($menu ne "" && [$menu cget -type] eq "tearoff")}]
if {($tearoff != 0) && $Priv(postedMb) eq $w  && $Priv(inMenubutton) eq $w} {
MenuFirstEntry [$Priv(postedMb) cget -menu]
} else {
MenuUnpost {}
}
}


proc ::tk::MenuMotion {menu x y state} {
variable ::tk::Priv
if {[string equal $menu $Priv(window)]} {
if {[string equal [$menu cget -type] "menubar"]} {
if {[info exists Priv(focus)] &&  [string compare $menu $Priv(focus)]} {
$menu activate @$x,$y
GenerateMenuSelect $menu
}
} else {
$menu activate @$x,$y
GenerateMenuSelect $menu
}
}
if {($state & 0x1f00) != 0} {
$menu postcascade active
}
}


proc ::tk::MenuButtonDown menu {
variable ::tk::Priv
global tcl_platform

if {![winfo viewable $menu]} {
return
}
$menu postcascade active
if {[string compare $Priv(postedMb) ""] &&  [winfo viewable $Priv(postedMb)]} {
grab -global $Priv(postedMb)
} else {
while {[string equal [$menu cget -type] "normal"]  && [string equal [winfo class [winfo parent $menu]] "Menu"]  && [winfo ismapped [winfo parent $menu]]} {
set menu [winfo parent $menu]
}

if {[string equal $Priv(menuBar) {}]} {
set Priv(menuBar) $menu
set Priv(cursor) [$menu cget -cursor]
$menu configure -cursor arrow
}


if {[string compare $menu [grab current $menu]]} {
SaveGrabInfo $menu
}


if {[string equal [tk windowingsystem] "x11"]} {
grab -global $menu
}
}
}


proc ::tk::MenuLeave {menu rootx rooty state} {
variable ::tk::Priv
set Priv(window) {}
if {[string equal [$menu index active] "none"]} {
return
}
if {[string equal [$menu type active] "cascade"]
&& [string equal [winfo containing $rootx $rooty]  [$menu entrycget active -menu]]} {
return
}
$menu activate none
GenerateMenuSelect $menu
}


proc ::tk::MenuInvoke {w buttonRelease} {
variable ::tk::Priv

if {$buttonRelease && [string equal $Priv(window) {}]} {

$w postcascade none
$w activate none
event generate $w <<MenuSelect>>
MenuUnpost $w
return
}
if {[string equal [$w type active] "cascade"]} {
$w postcascade active
set menu [$w entrycget active -menu]
MenuFirstEntry $menu
} elseif {[string equal [$w type active] "tearoff"]} {
::tk::TearOffMenu $w
MenuUnpost $w
} elseif {[string equal [$w cget -type] "menubar"]} {
$w postcascade none
set active [$w index active]
set isCascade [string equal [$w type $active] "cascade"]


if { $isCascade } {
$w activate none
event generate $w <<MenuSelect>>
}

MenuUnpost $w


if { !$isCascade } {
uplevel #0 [list $w invoke $active]
}
} else {
set active [$w index active]
if {$Priv(popup) eq "" || $active ne "none"} {
MenuUnpost $w
}
uplevel #0 [list $w invoke active]
}
}


proc ::tk::MenuEscape menu {
set parent [winfo parent $menu]
if {[string compare [winfo class $parent] "Menu"]} {
MenuUnpost $menu
} elseif {[string equal [$parent cget -type] "menubar"]} {
MenuUnpost $menu
RestoreOldGrab
} else {
MenuNextMenu $menu left
}
}


proc ::tk::MenuUpArrow {menu} {
if {[string equal [$menu cget -type] "menubar"]} {
MenuNextMenu $menu left
} else {
MenuNextEntry $menu -1
}
}

proc ::tk::MenuDownArrow {menu} {
if {[string equal [$menu cget -type] "menubar"]} {
MenuNextMenu $menu right
} else {
MenuNextEntry $menu 1
}
}

proc ::tk::MenuLeftArrow {menu} {
if {[string equal [$menu cget -type] "menubar"]} {
MenuNextEntry $menu -1
} else {
MenuNextMenu $menu left
}
}

proc ::tk::MenuRightArrow {menu} {
if {[string equal [$menu cget -type] "menubar"]} {
MenuNextEntry $menu 1
} else {
MenuNextMenu $menu right
}
}


proc ::tk::MenuNextMenu {menu direction} {
variable ::tk::Priv


if {[string equal $direction "right"]} {
set count 1
set parent [winfo parent $menu]
set class [winfo class $parent]
if {[string equal [$menu type active] "cascade"]} {
$menu postcascade active
set m2 [$menu entrycget active -menu]
if {[string compare $m2 ""]} {
MenuFirstEntry $m2
}
return
} else {
set parent [winfo parent $menu]
while {[string compare $parent "."]} {
if {[string equal [winfo class $parent] "Menu"]  && [string equal [$parent cget -type] "menubar"]} {
tk_menuSetFocus $parent
MenuNextEntry $parent 1
return
}
set parent [winfo parent $parent]
}
}
} else {
set count -1
set m2 [winfo parent $menu]
if {[string equal [winfo class $m2] "Menu"]} {
$menu activate none
GenerateMenuSelect $menu
tk_menuSetFocus $m2

$m2 postcascade none

if {[string compare [$m2 cget -type] "menubar"]} {
return
}
}
}


set m2 [winfo parent $menu]
if {[string equal [winfo class $m2] "Menu"]} {
if {[string equal [$m2 cget -type] "menubar"]} {
tk_menuSetFocus $m2
MenuNextEntry $m2 -1
return
}
}

set w $Priv(postedMb)
if {[string equal $w ""]} {
return
}
set buttons [winfo children [winfo parent $w]]
set length [llength $buttons]
set i [expr {[lsearch -exact $buttons $w] + $count}]
while {1} {
while {$i < 0} {
incr i $length
}
while {$i >= $length} {
incr i -$length
}
set mb [lindex $buttons $i]
if {[string equal [winfo class $mb] "Menubutton"]  && [string compare [$mb cget -state] "disabled"]  && [string compare [$mb cget -menu] ""]  && [string compare [[$mb cget -menu] index last] "none"]} {
break
}
if {[string equal $mb $w]} {
return
}
incr i $count
}
MbPost $mb
MenuFirstEntry [$mb cget -menu]
}


proc ::tk::MenuNextEntry {menu count} {

if {[string equal [$menu index last] "none"]} {
return
}
set length [expr {[$menu index last]+1}]
set quitAfter $length
set active [$menu index active]
if {[string equal $active "none"]} {
set i 0
} else {
set i [expr {$active + $count}]
}
while {1} {
if {$quitAfter <= 0} {

return
}
while {$i < 0} {
incr i $length
}
while {$i >= $length} {
incr i -$length
}
if {[catch {$menu entrycget $i -state} state] == 0} {
if {$state ne "disabled" &&  ($i!=0 || [$menu cget -type] ne "tearoff"  || [$menu type 0] ne "tearoff")} {
break
}
}
if {$i == $active} {
return
}
incr i $count
incr quitAfter -1
}
$menu activate $i
GenerateMenuSelect $menu

if {[string equal [$menu type $i] "cascade"]  && [string equal [$menu cget -type] "menubar"]} {
set cascade [$menu entrycget $i -menu]
if {[string compare $cascade ""]} {
$menu postcascade $i
MenuFirstEntry $cascade
}
}
}


proc ::tk::MenuFind {w char} {
set char [string tolower $char]
set windowlist [winfo child $w]

foreach child $windowlist {
if {[string compare [winfo toplevel $w] [winfo toplevel $child]]} {
continue
}
if {[string equal [winfo class $child] "Menu"] &&  [string equal [$child cget -type] "menubar"]} {
if {[string equal $char ""]} {
return $child
}
set last [$child index last]
for {set i [$child cget -tearoff]} {$i <= $last} {incr i} {
if {[string equal [$child type $i] "separator"]} {
continue
}
set char2 [string index [$child entrycget $i -label]  [$child entrycget $i -underline]]
if {[string equal $char [string tolower $char2]]  || [string equal $char ""]} {
if {[string compare [$child entrycget $i -state] "disabled"]} {
return $child
}
}
}
}
}

foreach child $windowlist {
if {[string compare [winfo toplevel $w] [winfo toplevel $child]]} {
continue
}
switch [winfo class $child] {
Menubutton {
set char2 [string index [$child cget -text]  [$child cget -underline]]
if {[string equal $char [string tolower $char2]]  || [string equal $char ""]} {
if {[string compare [$child cget -state] "disabled"]} {
return $child
}
}
}

default {
set match [MenuFind $child $char]
if {[string compare $match ""]} {
return $match
}
}
}
}
return {}
}


proc ::tk::TraverseToMenu {w char} {
variable ::tk::Priv
if {[string equal $char ""]} {
return
}
while {[string equal [winfo class $w] "Menu"]} {
if {[string compare [$w cget -type] "menubar"]  && [string equal $Priv(postedMb) ""]} {
return
}
if {[string equal [$w cget -type] "menubar"]} {
break
}
set w [winfo parent $w]
}
set w [MenuFind [winfo toplevel $w] $char]
if {[string compare $w ""]} {
if {[string equal [winfo class $w] "Menu"]} {
tk_menuSetFocus $w
set Priv(window) $w
SaveGrabInfo $w
grab -global $w
TraverseWithinMenu $w $char
} else {
MbPost $w
MenuFirstEntry [$w cget -menu]
}
}
}


proc ::tk::FirstMenu w {
variable ::tk::Priv
set w [MenuFind [winfo toplevel $w] ""]
if {[string compare $w ""]} {
if {[string equal [winfo class $w] "Menu"]} {
tk_menuSetFocus $w
set Priv(window) $w
SaveGrabInfo $w
grab -global $w
MenuFirstEntry $w
} else {
MbPost $w
MenuFirstEntry [$w cget -menu]
}
}
}


proc ::tk::TraverseWithinMenu {w char} {
if {[string equal $char ""]} {
return
}
set char [string tolower $char]
set last [$w index last]
if {[string equal $last "none"]} {
return
}
for {set i 0} {$i <= $last} {incr i} {
if {[catch {set char2 [string index  [$w entrycget $i -label] [$w entrycget $i -underline]]}]} {
continue
}
if {[string equal $char [string tolower $char2]]} {
if {[string equal [$w type $i] "cascade"]} {
$w activate $i
$w postcascade active
event generate $w <<MenuSelect>>
set m2 [$w entrycget $i -menu]
if {[string compare $m2 ""]} {
MenuFirstEntry $m2
}
} else {
MenuUnpost $w
uplevel #0 [list $w invoke $i]
}
return
}
}
}


proc ::tk::MenuFirstEntry menu {
if {[string equal $menu ""]} {
return
}
tk_menuSetFocus $menu
if {[string compare [$menu index active] "none"]} {
return
}
set last [$menu index last]
if {[string equal $last "none"]} {
return
}
for {set i 0} {$i <= $last} {incr i} {
if {([catch {set state [$menu entrycget $i -state]}] == 0)  && [string compare $state "disabled"]  && [string compare [$menu type $i] "tearoff"]} {
$menu activate $i
GenerateMenuSelect $menu
if {[string equal [$menu type $i] "cascade"] &&  [string equal [$menu cget -type] "menubar"]} {
set cascade [$menu entrycget $i -menu]
if {[string compare $cascade ""]} {
$menu postcascade $i
MenuFirstEntry $cascade
}
}
return
}
}
}


proc ::tk::MenuFindName {menu s} {
set i ""
if {![regexp {^active$|^last$|^none$|^[0-9]|^@} $s]} {
catch {set i [$menu index $s]}
return $i
}
set last [$menu index last]
if {[string equal $last "none"]} {
return
}
for {set i 0} {$i <= $last} {incr i} {
if {![catch {$menu entrycget $i -label} label]} {
if {[string equal $label $s]} {
return $i
}
}
}
return ""
}


proc ::tk::PostOverPoint {menu x y {entry {}}}  {
global tcl_platform

if {$entry ne ""} {
if {$entry == [$menu index last]} {
incr y [expr {-([$menu yposition $entry]  + [winfo reqheight $menu])/2}]
} else {
incr y [expr {-([$menu yposition $entry]  + [$menu yposition [expr {$entry+1}]])/2}]
}
incr x [expr {-[winfo reqwidth $menu]/2}]
}
if {$tcl_platform(platform) eq "windows"} {
set yoffset [expr {[winfo screenheight $menu]  - $y - [winfo reqheight $menu] - 10}]
if {$yoffset < 0} {
incr y $yoffset
if {$y < 0} { set y 0 }
}
if {$y < 0} {
set y 0
}
}
$menu post $x $y
if {$entry ne "" && [$menu entrycget $entry -state] ne "disabled"} {
$menu activate $entry
GenerateMenuSelect $menu
}
}


proc tk::SaveGrabInfo w {
variable ::tk::Priv
set Priv(oldGrab) [grab current $w]
if {$Priv(oldGrab) ne ""} {
set Priv(grabStatus) [grab status $Priv(oldGrab)]
}
}


proc ::tk::RestoreOldGrab {} {
variable ::tk::Priv

if {$Priv(oldGrab) ne ""} {

catch {
if {[string equal $Priv(grabStatus) "global"]} {
grab set -global $Priv(oldGrab)
} else {
grab set $Priv(oldGrab)
}
}
set Priv(oldGrab) ""
}
}

proc ::tk_menuSetFocus {menu} {
variable ::tk::Priv
if {![info exists Priv(focus)] || [string equal $Priv(focus) {}]} {
set Priv(focus) [focus]
}
focus $menu
}

proc ::tk::GenerateMenuSelect {menu} {
variable ::tk::Priv

if {[string equal $Priv(activeMenu) $menu]  && [string equal $Priv(activeItem) [$menu index active]]} {
return
}

set Priv(activeMenu) $menu
set Priv(activeItem) [$menu index active]
event generate $menu <<MenuSelect>>
}


proc ::tk_popup {menu x y {entry {}}} {
variable ::tk::Priv
global tcl_platform
if {$Priv(popup) ne "" || $Priv(postedMb) ne ""} {
tk::MenuUnpost {}
}
tk::PostOverPoint $menu $x $y $entry
if {[tk windowingsystem] eq "x11" && [winfo viewable $menu]} {
tk::SaveGrabInfo $menu
grab -global $menu
set Priv(popup) $menu
tk_menuSetFocus $menu
}
}
