

proc ::tk_setPalette {args} {
if {[winfo depth .] == 1} {
return
}


if {[llength $args] == 1} {
set new(background) [lindex $args 0]
} else {
array set new $args
}
if {![info exists new(background)]} {
error "must specify a background color"
}
set bg [winfo rgb . $new(background)]
if {![info exists new(foreground)]} {
foreach {r g b} $bg {break}
if {$r+1.5*$g+0.5*$b > 100000} {
set new(foreground) black
} else {
set new(foreground) white
}
}
set fg [winfo rgb . $new(foreground)]
set darkerBg [format #%02x%02x%02x [expr {(9*[lindex $bg 0])/2560}]  [expr {(9*[lindex $bg 1])/2560}] [expr {(9*[lindex $bg 2])/2560}]]
foreach i {activeForeground insertBackground selectForeground  highlightColor} {
if {![info exists new($i)]} {
set new($i) $new(foreground)
}
}
if {![info exists new(disabledForeground)]} {
set new(disabledForeground) [format #%02x%02x%02x  [expr {(3*[lindex $bg 0] + [lindex $fg 0])/1024}]  [expr {(3*[lindex $bg 1] + [lindex $fg 1])/1024}]  [expr {(3*[lindex $bg 2] + [lindex $fg 2])/1024}]]
}
if {![info exists new(highlightBackground)]} {
set new(highlightBackground) $new(background)
}
if {![info exists new(activeBackground)]} {

foreach i {0 1 2} {
set light($i) [expr {[lindex $bg $i]/256}]
set inc1 [expr {($light($i)*15)/100}]
set inc2 [expr {(255-$light($i))/3}]
if {$inc1 > $inc2} {
incr light($i) $inc1
} else {
incr light($i) $inc2
}
if {$light($i) > 255} {
set light($i) 255
}
}
set new(activeBackground) [format #%02x%02x%02x $light(0)  $light(1) $light(2)]
}
if {![info exists new(selectBackground)]} {
set new(selectBackground) $darkerBg
}
if {![info exists new(troughColor)]} {
set new(troughColor) $darkerBg
}
if {![info exists new(selectColor)]} {
set new(selectColor) #b03060
}

toplevel .___tk_set_palette
wm withdraw .___tk_set_palette
foreach q {
button canvas checkbutton entry frame label labelframe
listbox menubutton menu message radiobutton scale scrollbar
spinbox text
} {
$q .___tk_set_palette.$q
}


eval [tk::RecolorTree . new]

catch {destroy .___tk_set_palette}


foreach option [array names new] {
option add *$option $new($option) widgetDefault
}


array set ::tk::Palette [array get new]
}


proc ::tk::RecolorTree {w colors} {
upvar $colors c
set result {}
set prototype .___tk_set_palette.[string tolower [winfo class $w]]
if {![winfo exists $prototype]} {
unset prototype
}
foreach dbOption [array names c] {
set option -[string tolower $dbOption]
set class [string replace $dbOption 0 0 [string toupper  [string index $dbOption 0]]]
if {![catch {$w config $option} value]} {
set defaultcolor [option get $w $dbOption $class]
if {[string match {} $defaultcolor] ||  ([info exists prototype] &&  [$prototype cget $option] ne "$defaultcolor")} {
set defaultcolor [winfo rgb . [lindex $value 3]]
} else {
set defaultcolor [winfo rgb . $defaultcolor]
}
set chosencolor [winfo rgb . [lindex $value 4]]
if {[string match $defaultcolor $chosencolor]} {
append result ";\noption add [list  *[winfo class $w].$dbOption $c($dbOption) 60]"
$w configure $option $c($dbOption)
}
}
}
foreach child [winfo children $w] {
append result ";\n[::tk::RecolorTree $child c]"
}
return $result
}


proc ::tk::Darken {color percent} {
foreach {red green blue} [winfo rgb . $color] {
set red [expr {($red/256)*$percent/100}]
set green [expr {($green/256)*$percent/100}]
set blue [expr {($blue/256)*$percent/100}]
break
}
if {$red > 255} {
set red 255
}
if {$green > 255} {
set green 255
}
if {$blue > 255} {
set blue 255
}
return [format "#%02x%02x%02x" $red $green $blue]
}


proc ::tk_bisque {} {
tk_setPalette activeBackground #e6ceb1 activeForeground black  background #ffe4c4 disabledForeground #b0b0b0 foreground black  highlightBackground #ffe4c4 highlightColor black  insertBackground black selectColor #b03060  selectBackground #e6ceb1 selectForeground black  troughColor #cdb79e
}
