

proc ::tk::TearOffMenu {w {x 0} {y 0}} {

if {$x == 0} {
set x [winfo rootx $w]
}
if {$y == 0} {
set y [winfo rooty $w]
}

set parent [winfo parent $w]
while {[string compare [winfo toplevel $parent] $parent]  || [string equal [winfo class $parent] "Menu"]} {
set parent [winfo parent $parent]
}
if {[string equal $parent "."]} {
set parent ""
}
for {set i 1} 1 {incr i} {
set menu $parent.tearoff$i
if {![winfo exists $menu]} {
break
}
}

$w clone $menu tearoff


set parent [winfo parent $w]
if {[string compare [$menu cget -title] ""]} {
wm title $menu [$menu cget -title]
} else {
switch [winfo class $parent] {
Menubutton {
wm title $menu [$parent cget -text]
}
Menu {
wm title $menu [$parent entrycget active -label]
}
}
}

$menu post $x $y

if {[winfo exists $menu] == 0} {
return ""
}


bind $menu <Enter> {
set tk::Priv(focus) %W
}


set cmd [$w cget -tearoffcommand]
if {[string compare $cmd ""]} {
uplevel #0 $cmd [list $w $menu]
}
return $menu
}


proc ::tk::MenuDup {src dst type} {
set cmd [list menu $dst -type $type]
foreach option [$src configure] {
if {[llength $option] == 2} {
continue
}
if {[string equal [lindex $option 0] "-type"]} {
continue
}
lappend cmd [lindex $option 0] [lindex $option 4]
}
eval $cmd
set last [$src index last]
if {[string equal $last "none"]} {
return
}
for {set i [$src cget -tearoff]} {$i <= $last} {incr i} {
set cmd [list $dst add [$src type $i]]
foreach option [$src entryconfigure $i]  {
lappend cmd [lindex $option 0] [lindex $option 4]
}
eval $cmd
}


set tags [bindtags $src]
set srcLen [string length $src]


while {[set index [string first $src $tags]] != -1} {
append x [string range $tags 0 [expr {$index - 1}]]$dst
set tags [string range $tags [expr {$index + $srcLen}] end]
}
append x $tags

bindtags $dst $x

foreach event [bind $src] {
unset x
set script [bind $src $event]
set eventLen [string length $event]


while {[set index [string first $event $script]] != -1} {
append x [string range $script 0 [expr {$index - 1}]]
append x $dst
set script [string range $script [expr {$index + $eventLen}] end]
}
append x $script

bind $dst $event $x
}
}
